Program NPef_nearer

  use sep
  use read_hist_param
  use npef_find_nearer
  use nhelix
  use createnhelixmod
  use io_nfilt
  use error_check
  
  implicit none
  
  integer, external                  :: getch
  integer                            :: nl, niter, prec,ritestat,tt(1000),fiter,fprec,nliter,stat,dim,nh,vert,step,i
  integer, dimension(:), allocatable :: a,center,gap,npatch,patch,nn,nsc
  real                               :: eps, epsl, feps,fsig
  character(len=1024)                :: out,fname,mresout,dresout,mskout,mapout,coefout
  real,    dimension(:), pointer     :: data,mask,maskout
  integer, dimension(:,:,:), pointer     :: map
  real,    dimension(:), allocatable :: oo,dd,mod_res,dat_res
  type(nfilter)                      :: pef, pef2
  
! __________________________________________________________
! ___________Initialize and allocate parameters_____________
! __________________________________________________________
  call sep_init(SOURCE)
  dim = sep_dimension()
  allocate(nn(dim),oo(dim),dd(dim),a(dim),center(dim),gap(dim),npatch(dim),nsc(1))
! __________________________________________________________
! ___________Read history and parameters____________________
! __________________________________________________________
  call history_read(nn,oo,dd)
  call pefpar_read(a,center,gap,npatch,out)
  call cgpar_read(niter,prec,eps,epsl,nl)
!  call fillpar_read(fname,feps,fsig,fiter,fprec)
  call from_param("mresout",mresout,"mres.H")
  call from_param("dresout",dresout,"dres.H")
  call from_param("maskout",mskout,"maskout.H")
  call from_param("mapout",mapout,"mapout.H")
  call from_param("coefout",coefout,"coefout.H")
  call from_param("vert",vert,1)
  call from_param("step",step,0)
  
! __________________________________________________________
! ___________Allocate data arrays and read data_____________ 
! __________________________________________________________
  allocate(data(product(nn)),mask(product(nn)),patch(product(nn)),maskout(product(nn)))
  call sep_read(data)
  if (exist_file ("maskin")) then
     call sep_read(mask,"maskin")
  else
     mask=1.
  end if
! __________________________________________________________
! ___________Create PEF, set patch table (wrong)____________
! __________________________________________________________
  patch=product(npatch)

  pef = createnhelix( nn, center, gap, a, patch)
  allocate(mod_res(size(pef%hlx(1)%flt)*product(npatch)),dat_res(product(nn)))
! __________________________________________________________
! ___________Call main program to estimate PEF______________
! __________________________________________________________

!  pef2%pch=pef%pch
write(0,*)"NM PEF: pef",size(mod_res)
  call pefcheck(pef)
  allocate(map(nn(1),nn(2),2))
  call rmms(mask," mask")
!write(0,*)"NM PEF: pef2"
!  call pefcheck(pef2)
! __________________________________________________________
! ________________Do nonlinear iterations___________________
! __________________________________________________________
  
  call npef_find1(data,mask,nn,oo,dd,a,center,gap,npatch,niter,eps,prec,mod_res,dat_res,pef,epsl,nl,vert,map,step)
write(0,*)"N PEF: pef"
  call pefcheck(pef)
  maskout=1.
  where (pef%mis==.true.)
     maskout=0.
  end where

!write(0,*)"max coeff",maxval(pef2%hlx(150)%flt)
! __________________________________________________________
! ___________Write out filter to external file______________
! __________________________________________________________

  do i=1,maxval(pef%pch)
     call sep_write(pef%hlx(i)%flt,coefout)
  end do
  call to_history("n1",size(pef%hlx(1)%flt),coefout)
  call to_history("n2",nn(1),coefout)
  call to_history("n3",nn(2),coefout)
call rmms(maskout,"masko")
  call sep_write(maskout,mskout)
  call to_history("n1",nn(1),mskout)
  call to_history("n2",nn(2),mskout)
!call rmms(map,"masp")
write(0,*)"mapout",mapout,minval(map),maxval(map),size(map)

  call sep_write(real(map),mapout)
  call to_history("n1",nn(1),mapout)
  call to_history("n2",nn(2),mapout)
  call to_history("n3",2,mapout)
call rmms(dat_res,"datre")
  dat_res=dat_res*maskout
  call sep_write(dat_res,dresout)
  call to_history("n1",nn(1),dresout)
  call to_history("n2",nn(2),dresout)
call rmms(mod_res,"modre")
  call sep_write(mod_res,mresout)
  call to_history("n1",size(pef%hlx(1)%lag),mresout)
  call to_history("n2",npatch(1),mresout)
  call to_history("n3",npatch(2),mresout)
  ritestat=rite_nfilt(out,pef,nn,oo,dd)
! __________________________________________________________
! ___________Deallocate and close program___________________
! __________________________________________________________

  call sep_close()
  allocate(pef%mis(1),pef%pch(1));pef%pch=size(pef%hlx)
  call ndeallocate(pef)
  deallocate (nn,oo,dd,a,center,gap,npatch,data,mask,patch)
  call exit(0)
end Program NPef_nearer

