module error_check
use nhelix
use helix
contains

subroutine rmms(a,name)
  real, dimension(:)  :: a
  character(5) :: name
  write(0,*)"   array: ",name
  write(0,*)"      minimum: ",minval(a)
  write(0,*)"      maximum: ",maxval(a)
  write(0,*)"      size   : ",size(a)
end subroutine rmms

subroutine rmms2(a,name)
  real, dimension(:,:):: a
  character(5) :: name
  write(0,*)"   array: ",name
  write(0,*)"      minimum: ",minval(a)
  write(0,*)"      maximum: ",maxval(a)
  write(0,*)"      size 1 : ",size(a,1)
  write(0,*)"      size 2 : ",size(a,2)
end subroutine rmms2

subroutine imms(a,name)
  integer, dimension(:):: a
  character(5) :: name
  write(0,*)"   array: ",name
  write(0,*)"      minimum: ",minval(a)
  write(0,*)"      maximum: ",maxval(a)
  write(0,*)"      size   : ",size(a)
end subroutine imms

subroutine imms2(a,name)
  integer, dimension(:,:):: a
  character(5) :: name
  write(0,*)"   array: ",name
  write(0,*)"      minimum: ",minval(a)
  write(0,*)"      maximum: ",maxval(a)
  write(0,*)"      size 1 : ",size(a,1)
  write(0,*)"      size 2 : ",size(a,2)
end subroutine imms2

subroutine lmms(a,name)
  logical, dimension(:):: a
  character(5) :: name
  write(0,*)"   array: ",name
  write(0,*)"      count: ",count(a)
  write(0,*)"      size : ",size(a,1)
end subroutine lmms

subroutine pefcheck(pef)
  type(nfilter)  :: pef

  write(0,*)"   pef%hlx:"!,allocated(pef%hlx)
!  if (allocated(pef%hlx)) then
     write(0,*)"      size:",size(pef%hlx)
     write(0,*)"   pef%lag:"!,allocated(pef%hlx(1)%lag)
!     if (allocated(pef%hlx(1)%lag)) then
        write(0,*)"      size:",size(pef%hlx(1)%lag)
        write(0,*)"       min:",minval(pef%hlx(1)%lag)
        write(0,*)"       max:",maxval(pef%hlx(1)%lag)
!     end if
!  end if
  

  write(0,*)"   pef%mis:"!,allocated(pef%mis)
!  if (allocated(pef%mis)) then
     write(0,*)"       size:",size(pef%mis)
     write(0,*)"      count:",count(pef%mis)
!  end if
  write(0,*)"   pef%pch:"!,allocated(pef%pch)
!  if (allocated(pef%pch)) then
     write(0,*)"       size:",size(pef%pch)
     write(0,*)"        min:",minval(pef%pch)
     write(0,*)"        max:",maxval(pef%pch)
!  end if
end subroutine pefcheck

subroutine spefcheck(pef)
  type(filter)  :: pef

  write(0,*)"   pef%lag:"
  write(0,*)"      size:",size(pef%lag)
  write(0,*)"       min:",minval(pef%lag)
  write(0,*)"       max:",maxval(pef%lag)

  write(0,*)"   pef%mis:"!,allocated(pef%mis)
!  if (allocated(pef%mis)) then
     write(0,*)"       size:",size(pef%mis)
     write(0,*)"      count:",count(pef%mis)
!  end if
  write(0,*)"   pef%flt:"!,allocated(pef%flt)
!  if (allocated(pef%flt)) then
     write(0,*)"       size:",size(pef%flt)
     write(0,*)"        min:",minval(pef%flt)
     write(0,*)"        max:",maxval(pef%flt)
!  end if
end subroutine spefcheck

end module error_check
