module near2
! grabs nearest point, differences with current point
  use adj_mod
  implicit none
  logical ,private, dimension(:,:),   pointer  :: m 
  integer, private, dimension(:,:,:), pointer  :: map
  integer, private                             :: n1,n2
  contains 
  subroutine near2_init ( m_in,map_in,n1_in,n2_in )
    logical ,  dimension(:,:),   pointer :: m_in 
    integer ,  dimension(:,:,:), pointer :: map_in
    integer                              :: n1_in,n2_in
    m => m_in
    map => map_in
    n1 = n1_in
    n2 = n2_in
  end subroutine
  function near2_lop ( adj, add, x, y) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: x,y 

    call adjnull (adj,add,x,y )
    call near2_lop2(adj,x,y )
    stat=0
  end function 
  subroutine near2_lop2(adj,x,y)
    logical,intent(in) :: adj 
    real, dimension (n1,n2)  :: x 
    real, dimension (n1,n2)  :: y 
    integer              :: i,j

    do i=1,n1
       do j=1,n2
          if (m(i,j)) then
             if ( adj) then
                x(map(i,j,1),map(i,j,2))=x(map(i,j,1),map(i,j,2))-y(i,j)
                x(i,j)                  =x(i,j)                  +y(i,j)
             else
                y(i,j) = y(i,j) + x(i,j) - x(map(i,j,1),map(i,j,2))
             end if
          end if
       end do
    end do
  end subroutine 
  subroutine near2_close()
  end subroutine 
end module 
