module nsdiv
  use  nhelicon 
  use  cgstep_mod 
  use  solver_smp_mod
  use  random_mod
implicit none
  contains
! fill in missing data by minimizing power out of a given filter.
! by helix magic works in any number of dimensions
  subroutine nsdiv_data( niter, dd, xx, aa )
    integer,                intent( in)     :: niter
    type( nfilter),         intent( in)     :: aa
    real,    dimension( :), intent( in)     :: dd	! fitting variables
    real,    dimension( :), intent( out)    :: xx
    real,    dimension( :), allocatable     :: res
    logical, dimension( :), pointer         :: kk
    integer                                 :: nx
    real                                    :: sigma,eps
    nx = size( xx)
write(0,*)"max/min/size res",maxval(res),minval(res),size(res)
write(0,*)"max/min/size xx",maxval(xx),minval(xx),size(xx),count(xx/=0)
!    allocate(dd(nx))
write(0,*)"die -1"
!    dd=0
write(0,*)"die 0"
write(0,*)"die 1"
   xx=dd
!    where (.not.known)
!       dd=res
!    elsewhere
!       dd=xx
!    end where
write(0,*)"die 2"
!  regularized
      write(0,*)"min/max/size dd",minval(dd),maxval(dd),size(dd),count(dd/=0)
      write(0,*)"min/max/size xx",minval(xx),maxval(xx),size(xx),count(xx/=0)
      call nhelicon_init( aa)
      call solver_smp( m=xx,                           &
                       d=dd,                           &
                       Fop=nhelicon_lop,               &
                       stepper=cgstep,                 &
                       niter=niter,                    &
                       verb=.true.)
      write(0,*)"min/max/size dd",minval(dd),maxval(dd),size(dd),count(dd/=0)
      write(0,*)"min/max/size xx",minval(xx),maxval(xx),size(xx),count(xx/=0)
    call cgstep_close( )
  end subroutine 
end module 
