module nsfill_real
  use mask1 
  use  nhelicon 
  use  npolydiv 
  use  cgstep_mod 
!  use  solver_mod
  use  solver_reg_mod
  use  random_mod
implicit none
  contains
! fill in missing data by minimizing power out of a given filter.
! by helix magic works in any number of dimensions
  subroutine nsfill_data( niter, dd, xx, aa, known, doprec, wght, eps, r0 )
    logical,                intent( in)     :: doprec
    integer,                intent( in)     :: niter
    type( nfilter),         intent( in)     :: aa
    logical, dimension( :), intent( in)     :: known
    real,    dimension( :), intent( in)     :: wght
    real,    dimension( :), intent( in)     :: dd,r0	! fitting variables
    real,    dimension( :), intent( out)    :: xx
    real,    dimension( :), allocatable     :: res
    real,    dimension( :), pointer         :: resid0
    logical, dimension( :), pointer         :: kk
    integer                                 :: nx
    real                                    :: sigma,eps
    nx = size( xx)
    allocate(res(nx),resid0(nx))
    resid0=r0
write(0,*)"max/min/size res",maxval(res),minval(res),size(res)
write(0,*)"max/min/size xx",maxval(xx),minval(xx),size(xx),count(xx/=0)
!    allocate(dd(nx))
write(0,*)"die -1"
!    dd=0
write(0,*)"die 0"
write(0,*)"die 1"
where (known)
   xx=dd
end where
!    where (.not.known)
!       dd=res
!    elsewhere
!       dd=xx
!    end where
write(0,*)"die 2"
    if ( doprec) then
!  preconditioned
write(0,*) 'mis2x - a'
      allocate( kk( nx))
      kk = known
      call mask1_init( kk)
      call npolydiv_init( nx, aa)
write(0,*) 'mis2x - b'
!      call solver_prec( mask1_lop, cgstep, niter=niter, x=xx, dat=dd,prec= npolydiv_lop, nprec= nx, eps= 0., wt=wght)
write(0,*) 'mis2x - c'
      call npolydiv_close()
      deallocate( kk)
    else
!  regularized
      allocate( kk( nx))
      kk = known
      call mask1_init( kk)
      write(0,*)"count known",count(known)
      write(0,*)"min/max/size dd",minval(dd),maxval(dd),size(dd),count(dd/=0)
      write(0,*)"min/max/size xx",minval(xx),maxval(xx),size(xx),count(xx/=0)
      call nhelicon_init( aa)
      call solver_reg( m=xx,                           &
                       d=dd,                           &
                       Fop=mask1_lop,                  &
                       Aop=nhelicon_lop,               &
                       stepper=cgstep,                 &
                       nAop=nx,                        &
                       niter=niter,                    &
                       eps=eps,                        &
                       rm0=resid0,                     &
                       verb=.true.)
!      call solver( nhelicon_lop, cgstep, niter=niter, x=xx, dat=dd&
!        &, known=known, x0=xx, wt=wght)
      write(0,*)"min/max/size dd",minval(dd),maxval(dd),size(dd),count(dd/=0)
      write(0,*)"min/max/size xx",minval(xx),maxval(xx),size(xx),count(xx/=0)
      deallocate( res)
    end if 
    call cgstep_close( )
  end subroutine 
end module 
