module read_hist_param

use sep

contains

subroutine history_read  (n,o,d)
  integer,dimension(:) :: n
  real,   dimension(:) ::   o,d
  call from_history( "n", n)
  call from_history( "d", d)
  call from_history( "o", o)
end subroutine history_read

subroutine cgpar_read(niter,prec,eps,epsl,nl)
  integer    ::       niter,prec,         nl
  real       ::                  eps,epsl
  
  call from_param ("niter", niter, 1)
  call from_param ("prec",prec,1)
  call from_param ("eps",eps,0.)
  call from_param ("epsl",epsl,0.)
  call from_param ("nl",nl,10)
  
end subroutine cgpar_read

subroutine pefpar_read(   a,center,gap,npatch,out)
  integer,dimension(:) :: a,center,gap,npatch
  integer              :: dim
  character(len=1024)  ::                     out
  dim=size(a)
  call from_param( "a", a )
  center=1;  where( a(2:) > 1) center (:dim-1) = a (:dim-1)/2+1
  call from_param ("center", center, center)
  gap = 0
  call from_param ("gap", gap, gap)
  npatch=1
  call from_param ("npatch", npatch, npatch)
    call from_param ("out",out,'pef.H')
end subroutine pefpar_read

subroutine mspar_read  (jump,sc)
  integer,dimension(:)::jump,sc
  integer             ::tt(1000),nsc 
  nsc = getch("sc","d",tt)
  sc=0
  sc(1:nsc)=tt(1:nsc)
  call from_param ("sc", sc)
  jump=1
  call from_param ("jump",jump,jump)
end subroutine mspar_read

subroutine fillpar_read(fname,feps,fsig,fiter,fprec)
  character(len=1024):: fname
  real               ::       feps,fsig
  integer            ::                 fiter,fprec
  call from_param ("filt",fname,'pef.H')
  call from_param ("feps",feps,0.1)
  call from_param ("fsig",fsig,0.)
  call from_param ("fiter",fiter,100)
  call from_param ("fprec",fprec,0)
end subroutine fillpar_read

subroutine fillgpar_read  (fn,fo,fd)
  integer,dimension(:) ::  fn
  real,   dimension(:) ::     fo,fd
  call from_param( "fn", fn)
  call from_param( "fd", fd)
  call from_param( "fo", fo)
end subroutine fillgpar_read

subroutine hist_nod(n,o,d)
  integer,dimension(:)::n
  real,dimension(:)   ::o,d
  integer             ::dim
  dim=size(n)
  if (dim>=1) then
     call to_history("n1",n(1));call to_history("o1",o(1));call to_history("d1",d(1))
  end if
  if (dim>=2) then
     call to_history("n2",n(2));call to_history("o2",o(2));call to_history("d2",d(2))
  else
     call to_history("n2",1)     
  end if
  if (dim>=3) then
     call to_history("n3",n(3));call to_history("o3",o(3));call to_history("d3",d(3))
  else
     call to_history("n3",1)     
  end if
  if (dim>=4) then
     call to_history("n4",n(4));call to_history("o4",o(4));call to_history("d4",d(4))
  else
     call to_history("n4",1)     
  end if
  if (dim>=5) then
     call to_history("n5",n(5));call to_history("o5",o(5));call to_history("d5",d(5))
  else
     call to_history("n5",1)     
  end if
end subroutine hist_nod

end module read_hist_param


